/* spool */

#include <stdio.h>
#include <signal.h>
#include "spool.h"

int spool ();

main ()
{
  grava_pid (getpid ());
  while (1) {
    signal (SIGUSR1, spool);
    pause();
  }
}
 
spool ()
{

  char nseq_asc [10], cmd [512];

  if (varre_fila (nseq_asc) == OK) {
    strcpy (cmd, "spooler ");
    strcat (cmd, nseq_asc);
    strcat (cmd, "&");
    system (cmd); 
  }
}

varre_fila (nseq)
char *nseq;
{

  FILE *fdfila;
  char buffer [512], buffer_imp [512], imp_est [60], req_est [60],
       req_form [60], imp_form [60], req_impr [60];

  if ((fdfila=fopen (TABFILA, "r+w")) == NULL) {
    printf ("Erro na abertura do arquivo %s.\n", TABFILA);
    exit (ERRO);
  }
  while (pega_prox_req_ativa (fdfila, buffer) == OK) /* Achar uma requisicao */
  {                                                  /* que esteja pronta    */
    int fdimp;                                       /* para ser impressa.   */

    pega_cpo (buffer, FILSIT, req_est, TOKEN); 
    if (strcmp (req_est, AGUARDANDOIMPR) && strcmp (req_est, REIMPRIMIR))
      continue;
    pega_cpo (buffer, FILIMP, req_impr, TOKEN);
    abre (&fdimp, TABIMP, "r");
    if (pesq_reg (fdimp, buffer_imp, TAMIMP, req_impr) != OK) {
      close (fdimp);
      continue;
    } 
    close (fdimp);
    pega_cpo (buffer_imp, IMPEST,imp_est, TOKEN);
    if (strcmp (imp_est, ATIVADA))
      continue;
    pega_cpo (buffer, FILFOR, req_form, TOKEN);
    pega_cpo (buffer_imp, IMPFOR, imp_form, TOKEN);
    if (strcmp (req_form, imp_form))
      continue;
    poe_cpo (buffer_imp, IMPEST, IMPRIMINDO);
    grava_imp (req_impr, buffer_imp);
    poe_cpo (buffer, FILSIT, SENDOIMPRESSO);
    pega_cpo (buffer, FILREQ, nseq, TOKEN);
    grava_req (nseq, buffer);
    fclose (fdfila);
    return (OK);
  }
  fclose (fdfila);
  return (ERRO);
}
